<?php
/**
 * Retrieves and creates the wp-config.php file.
 *
 * The permissions for the base directory must allow for writing files in order
 * for the wp-config.php to be created using this page.
 *
 * @internal This file must be parsable by PHP4.
 *
 * @package WordPress
 * @subpackage Administration
 */

/**
 * We are installing.
 *
 * @package WordPress
 */
define('WP_INSTALLING', true);

/**
 * We are blissfully unaware of anything.
 */
define('WP_SETUP_CONFIG', true);

/**
 * Disable error reporting
 *
 * Set this to error_reporting( E_ALL ) or error_reporting( E_ALL | E_STRICT ) for debugging
 */
error_reporting(0);

/**#@+
 * These three defines are required to allow us to use require_wp_db() to load
 * the database class while being wp-content/db.php aware.
 * @ignore
 */
define('ABSPATH', dirname(dirname(__FILE__)).'/');
define('WPINC', 'wp-includes');
define('WP_CONTENT_DIR', ABSPATH . 'wp-content');
define('WP_DEBUG', false);
/**#@-*/

require_once(ABSPATH . WPINC . '/load.php');
require_once(ABSPATH . WPINC . '/version.php');
wp_check_php_mysql_versions();

require_once(ABSPATH . WPINC . '/compat.php');
require_once(ABSPATH . WPINC . '/functions.php');
require_once(ABSPATH . WPINC . '/class-wp-error.php');

if (!file_exists(ABSPATH . 'wp-config-sample.php'))
	wp_die('மன்னிக்கவும், wp-config-sample.php கோப்பு உங்கள் வழங்கியில் இருந்தால் மட்டுமே என்னால் வேலைசெய்ய முடியும். தயவுசெய்து அக்கோப்பை வழங்கியினுள் தரவேற்றிவிடுங்கள்.');

$configFile = file(ABSPATH . 'wp-config-sample.php');

// Check if wp-config.php has been created
if (file_exists(ABSPATH . 'wp-config.php'))
	wp_die("<p>'wp-config.php' ஏலவே உங்கள் கோப்புறையினுள் உள்ளது. அதனில் ஏதாவது மாற்றங்கள் செய்ய விரும்பின் முதலில் அதனை நீங்கள் நீக்க வேண்டும். இப்பொழுது நீங்கள்<a href='install.php'>நிறுவலை தொடங்க </a>முடியும்.</p>");

// Check if wp-config.php exists above the root directory but is not part of another install
if (file_exists(ABSPATH . '../wp-config.php') && ! file_exists(ABSPATH . '../wp-settings.php'))
	wp_die("<p>'wp-config.php' ஏலவே உங்கள் கோப்புறையினுள் உள்ளது. அதனில் ஏதாவது மாற்றங்கள் செய்ய விரும்பின் முதலில் அதனை நீங்கள் நீக்க வேண்டும். இப்பொழுது நீங்கள்<a href='install.php'>நிறுவலை தொடங்க </a>முடியும்.</p>");

if (isset($_GET['step']))
	$step = $_GET['step'];
else
	$step = 0;

/**
 * Display setup wp-config.php file header.
 *
 * @ignore
 * @since 2.3.0
 * @package WordPress
 * @subpackage Installer_WP_Config
 */
function display_header() {
	header( 'Content-Type: text/html; charset=utf-8' );
?>
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>வேர்ட்பிரஸ் நிறுவல்</title>
<link rel="stylesheet" href="css/install.css" type="text/css" />

</head>
<body>
<h1 id="logo"><img alt="WordPress" src="images/wordpress-logo.png" /></h1>
<?php
}//end function display_header();

switch($step) {
	case 0:
		display_header();
?>

<p>வேர்ட்பிரஸிற்கு உங்களை வரவேற்கின்றோம். நிறுவலை தொடங்க முன்னர் கீழ்வரும் உங்கள் தரவுத்தளத்தைப்பற்றிய விபரங்கள் உங்களுக்குத் தேவைப்படும்.</p>
<ol>
	<li>தரவுத்தளப் பெயர்</li>
	<li>தரவுத்தள பயனர் பெயர்</li>
	<li>தரவுத்தள கடவுச்சொல்</li>
	<li>தரவுத்தள host</li>
	<li>அட்டவணை முன்குறி (நீங்கள் ஒரே தரவுத்தளத்தில் பல வேர்ட்பிரஸ்களை நிறுவ விரும்பின் இது பயன்படும்) </li>
</ol>
<p><strong>ஏதாவது ஒரு காரணத்துக்காக இந்த தன்னியக்க கோப்புருவாக்கம் வேலை செய்யாவிடின் கவலைப்படவேண்டாம். இது உங்கள் கட்டமைப்பு கோப்பில் உங்கள் தரவுத்தளம் தொடர்பான விபரங்களை நிரப்பும் பணியை மட்டுமே செய்கின்றது. நீங்கள் வேண்டுமானால் <code>wp-config-sample.php</code> கோப்பினை திறந்து, தரவுத்தள விபரங்களை பூர்த்தி செய்து <code>wp-config.php</code> என்ற பெயரில் சேமித்துக்கொள்ள முடியும். </strong></p>
<p>அனேகமான நேரங்களில் உங்கள் வழங்கி வழங்குனரே இந்த விபரங்களையும் தருவார். உங்களிடம் அவை இல்லாவிடின், தொடரமுன் அவர்களை தொடர்புகொண்டு அத்தகவல்களை பெற்றுக்கொள்ளுங்கள். எல்லா விபரங்களும் உங்களிடமிருப்பின்&hellip;</p>

<p class="step"><a href="setup-config.php?step=1<?php if ( isset( $_GET['noapi'] ) ) echo '&amp;noapi'; ?>" class="button">தொடங்குங்கள்!</a></p>
<?php
	break;

	case 1:
		display_header();
	?>
<form method="post" action="setup-config.php?step=2">
	<p>கீழே உங்கள் தரவுத்தளம் தொடர்பான விபரங்களை உள்ளிடுங்கள். விபரங்கள் சரியாகத் தெரியாவிடின், உங்கள் இணைய வழங்கி வழங்குனரை தொடர்புகொள்ளுங்கள். </p>
	<table class="form-table">
		<tr>
			<th scope="row"><label for="dbname">தரவுத்தளப் பெயர்</label></th>
			<td><input name="dbname" id="dbname" type="text" size="25" value="wordpress" /></td>
			<td>நீங்கள் வேர்ட்பிரஸை நிறுவ விரும்புகின்ற தரவுத்தளத்தின் பெயர். </td>
		</tr>
		<tr>
			<th scope="row"><label for="uname">பயனர் பெயர்</label></th>
			<td><input name="uname" id="uname" type="text" size="25" value="username" /></td>
			<td>உங்கள் MySQL பயனர் பெயர்</td>
		</tr>
		<tr>
			<th scope="row"><label for="pwd">கடவுச்சொல்</label></th>
			<td><input name="pwd" id="pwd" type="text" size="25" value="password" /></td>
			<td>அத்தோடு உங்கள் MySQL கடவுச்சொல்.</td>
		</tr>
		<tr>
			<th scope="row"><label for="dbhost">தரவுத்தள Host</label></th>
			<td><input name="dbhost" id="dbhost" type="text" size="25" value="localhost" /></td>
			<td><code>localhost</code> என்பது வேலை செய்யாவிடின், உங்கள் வழங்கி வழங்குனர் இதனை தந்திருப்பார்.</td>
		</tr>
		<tr>
			<th scope="row"><label for="prefix">அட்டவணை முன்குறி</label></th>
			<td><input name="prefix" id="prefix" type="text" value="wp_" size="25" /></td>
			<td>ஒரே தரவுத்தளத்தில் பல வேர்ட்பிரஸ்களை நிறுவ விரும்பின் இதனை மாற்றுங்கள்</td>
		</tr>
	</table>
	<?php if ( isset( $_GET['noapi'] ) ) { ?><input name="noapi" type="hidden" value="true" /><?php } ?>
	<p class="step"><input name="submit" type="submit" value="சமர்ப்பி" class="button" /></p>
</form>
<?php
	break;

	case 2:
	$dbname  = trim($_POST['dbname']);
	$uname   = trim($_POST['uname']);
	$passwrd = trim($_POST['pwd']);
	$dbhost  = trim($_POST['dbhost']);
	$prefix  = trim($_POST['prefix']);
	if ( empty($prefix) )
		$prefix = 'wp_';

	// Validate $prefix: it can only contain letters, numbers and underscores
	if ( preg_match( '|[^a-z0-9_]|i', $prefix ) )
		wp_die( /*WP_I18N_BAD_PREFIX*/'<strong>ERROR</strong>: "Table Prefix" can only contain numbers, letters, and underscores.'/*/WP_I18N_BAD_PREFIX*/ );

	// Test the db connection.
	/**#@+
	 * @ignore
	 */
	define('DB_NAME', $dbname);
	define('DB_USER', $uname);
	define('DB_PASSWORD', $passwrd);
	define('DB_HOST', $dbhost);
	/**#@-*/

	// We'll fail here if the values are no good.
	require_wp_db();
	if ( ! empty( $wpdb->error ) ) {
		$back = '<p class="step"><a href="setup-config.php?step=1" onclick="javascript:history.go(-1);return false;" class="button">Try Again</a></p>';
		wp_die( $wpdb->error->get_error_message() . $back );
	}

	// Fetch or generate keys and salts.
	$no_api = isset( $_POST['noapi'] );
	require_once( ABSPATH . WPINC . '/plugin.php' );
	require_once( ABSPATH . WPINC . '/l10n.php' );
	require_once( ABSPATH . WPINC . '/pomo/translations.php' );
	if ( ! $no_api ) {
		require_once( ABSPATH . WPINC . '/class-http.php' );
		require_once( ABSPATH . WPINC . '/http.php' );
		wp_fix_server_vars();
		/**#@+
		 * @ignore
		 */
		function get_bloginfo() {
			return ( ( is_ssl() ? 'https://' : 'http://' ) . $_SERVER['HTTP_HOST'] . str_replace( $_SERVER['PHP_SELF'], '/wp-admin/setup-config.php', '' ) );
		}
		/**#@-*/
		$secret_keys = wp_remote_get( 'https://api.wordpress.org/secret-key/1.1/salt/' );
	}

	if ( $no_api || is_wp_error( $secret_keys ) ) {
		$secret_keys = array();
		require_once( ABSPATH . WPINC . '/pluggable.php' );
		for ( $i = 0; $i < 8; $i++ ) {
			$secret_keys[] = wp_generate_password( 64, true, true );
		}
	} else {
		$secret_keys = explode( "\n", wp_remote_retrieve_body( $secret_keys ) );
		foreach ( $secret_keys as $k => $v ) {
			$secret_keys[$k] = substr( $v, 28, 64 );
		}
	}
	$key = 0;

	foreach ($configFile as $line_num => $line) {
		switch (substr($line,0,16)) {
			case "define('DB_NAME'":
				$configFile[$line_num] = str_replace("database_name_here", $dbname, $line);
				break;
			case "define('DB_USER'":
				$configFile[$line_num] = str_replace("'username_here'", "'$uname'", $line);
				break;
			case "define('DB_PASSW":
				$configFile[$line_num] = str_replace("'password_here'", "'$passwrd'", $line);
				break;
			case "define('DB_HOST'":
				$configFile[$line_num] = str_replace("localhost", $dbhost, $line);
				break;
			case '$table_prefix  =':
				$configFile[$line_num] = str_replace('wp_', $prefix, $line);
				break;
			case "define('AUTH_KEY":
			case "define('SECURE_A":
			case "define('LOGGED_I":
			case "define('NONCE_KE":
			case "define('AUTH_SAL":
			case "define('SECURE_A":
			case "define('LOGGED_I":
			case "define('NONCE_SA":
				$configFile[$line_num] = str_replace('put your unique phrase here', $secret_keys[$key++], $line );
				break;
		}
	}
	if ( ! is_writable(ABSPATH) ) :
		display_header();
?>
<p>மன்னிக்கவும் என்னால் <code>wp-config.php</code> கோப்பை உருவாக்க முடியவில்லை.</p>
<p><code>wp-config.php</code> நீங்களாகவே உருவாக்கி கீழ்வரும் விபரத்தை அதனுள் சேர்த்துவிடுங்கள்.</p>
<textarea cols="98" rows="15" class="code"><?php
		foreach( $configFile as $line ) {
			echo htmlentities($line, ENT_COMPAT, 'UTF-8');
		}
?></textarea>
<p>அதனை செய்த பின்னர், "நிறுவலை தொடர்க" பொத்தானை அழுத்துங்கள்</p>
<p class="step"><a href="install.php" class="button">நிறுவலை தொடர்க</a></p>
<?php
	else :
		$handle = fopen(ABSPATH . 'wp-config.php', 'w');
		foreach( $configFile as $line ) {
			fwrite($handle, $line);
		}
		fclose($handle);
		chmod(ABSPATH . 'wp-config.php', 0666);
		display_header();
?>
<p>எல்லாம் சரி! வேர்ட்பிரஸினால் தரவுத்தளத்துடன் தொடர்பினை ஏற்படுத்த முடிகின்றது. நீங்கள் தயாராயின் &hellip;</p>

<p class="step"><a href="install.php" class="button">நிறுவுங்கள்</a></p>
<?php
	endif;
	break;
}
?>
</body>
</html>